//La librairie principale OSLib
#include <oslib/oslib.h>

//les callbacks
PSP_MODULE_INFO("OSLib Sample", 0, 1, 1);
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);

//definition des pointeurs vers nos images
OSL_IMAGE *fond, *boo;

//variables
int zoom = 160;
int alpha = 128;

int main()
{
	//Initialisation de la librairie
	oslInit(0);

	//Initialisation du mode graphique
	oslInitGfx(OSL_PF_8888, 1);

	//definition de la transparence
	oslSetTransparentColor(RGB(255,0,255));

	//chargement de nos images (oui, le "loading" :p)
	fond = oslLoadImageFile("fond_boss.png", OSL_IN_RAM, OSL_PF_5551);
	boo = oslLoadImageFile("boo.png", OSL_IN_RAM, OSL_PF_5551);	

	//plus de transparence
	oslDisableTransparentColor();

	//vrification
	if (!fond || !boo)
		oslDebug("Verifiez que tous les fichiers sont bien copis dans le rpertoire du jeu.");

	//centre du sprite
	boo->centerX = boo->sizeX / 2;		
	boo->centerY = boo->sizeY / 2;
	
	//on le place au centre de l'cran
	boo->x = 240;							
	boo->y = 136;
	
	//boucle principale
	while (!osl_quit)
	{
		//Permet de dessiner
		oslStartDrawing();
		
		//Lit les touches
		oslReadKeys();
		
		//deplace le sprite de boo
		if (osl_keys->held.down) boo->y += 2;
		if (osl_keys->held.up) boo->y -= 2;
		if (osl_keys->held.left) boo->x -= 2;
		if (osl_keys->held.right) boo->x += 2;

		//effectue une rotation sur boo
		if (osl_keys->held.L) boo->angle -= 2;
		if (osl_keys->held.R) boo->angle += 2;

		//zoome le sprite de boo
		if (osl_keys->held.square && zoom < 400) { boo->stretchX++; boo->stretchY++; zoom++; } 
		if (osl_keys->held.circle &&  zoom > 0 ) { boo->stretchX--; boo->stretchY--; zoom--; }
		
		//reglage de la transparence
		if (osl_keys->held.triangle && alpha > 0) alpha--;
		if (osl_keys->held.cross &&  alpha < 255) alpha++;

		//dessine nos images		
		oslDrawImage(fond);

		//active la transparence
		oslSetAlpha(OSL_FX_ALPHA,alpha);

		oslDrawImage(boo);

		//desactive la transparence
		oslSetAlpha(OSL_FX_NONE,alpha);
		
		//Fin du dessin
		oslEndDrawing();

		//Synchronise l'cran
		oslSyncFrame();		
	}
	
	//on quitte l'application
	oslEndGfx();
	oslQuit();
	return 0;
}
